package com.app.yourradioapp.activities;

import android.annotation.SuppressLint;
import android.app.ActivityManager;
import android.app.AlarmManager;
import android.app.PendingIntent;
import android.content.Context;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.content.res.AssetManager;
import android.graphics.Color;
import android.graphics.PorterDuff;
import android.graphics.drawable.ColorDrawable;
import android.media.AudioManager;
import android.net.Uri;
import android.os.Build;
import android.os.Bundle;
import android.os.Handler;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.MenuItem;
import android.view.View;
import android.view.WindowManager;
import android.view.inputmethod.InputMethodManager;
import android.widget.Button;
import android.widget.FrameLayout;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.ProgressBar;
import android.widget.RelativeLayout;
import android.widget.SeekBar;
import android.widget.TextView;
import android.widget.Toast;

import androidx.annotation.NonNull;
import androidx.appcompat.app.ActionBar;
import androidx.appcompat.app.ActionBarDrawerToggle;
import androidx.appcompat.app.AlertDialog;
import androidx.appcompat.app.AppCompatActivity;
import androidx.appcompat.widget.Toolbar;
import androidx.coordinatorlayout.widget.CoordinatorLayout;
import androidx.core.content.ContextCompat;
import androidx.core.view.GravityCompat;
import androidx.drawerlayout.widget.DrawerLayout;
import androidx.fragment.app.Fragment;
import androidx.fragment.app.FragmentManager;
import androidx.fragment.app.FragmentTransaction;

import com.android.volley.Request;
import com.android.volley.toolbox.JsonObjectRequest;
import com.app.yourradioapp.BuildConfig;
import com.app.yourradioapp.Config;
import com.app.yourradioapp.R;
import com.app.yourradioapp.fragments.FragmentRadio;
import com.app.yourradioapp.fragments.FragmentSearch;
import com.app.yourradioapp.fragments.FragmentSettings;
import com.app.yourradioapp.fragments.FragmentSocial;
import com.app.yourradioapp.fragments.FragmentTabLayout;
import com.app.yourradioapp.models.ItemRadio;
import com.app.yourradioapp.services.RadioPlayerService;
import com.app.yourradioapp.utils.AdsPref;
import com.app.yourradioapp.utils.AppBarLayoutBehavior;
import com.app.yourradioapp.utils.Constant;
import com.app.yourradioapp.utils.DatabaseHandler;
import com.app.yourradioapp.utils.GDPR;
import com.app.yourradioapp.utils.NativeTemplateStyle;
import com.app.yourradioapp.utils.SharedPref;
import com.app.yourradioapp.utils.SleepTimeReceiver;
import com.app.yourradioapp.utils.StatusBarView;
import com.app.yourradioapp.utils.TemplateView;
import com.app.yourradioapp.utils.ThemePref;
import com.app.yourradioapp.utils.Tools;
import com.facebook.ads.Ad;
import com.facebook.ads.AdError;
import com.facebook.ads.AdOptionsView;
import com.facebook.ads.AdSize;
import com.facebook.ads.NativeAd;
import com.facebook.ads.NativeAdLayout;
import com.facebook.ads.NativeAdListener;
import com.google.android.gms.ads.AdListener;
import com.google.android.gms.ads.AdLoader;
import com.google.android.gms.ads.AdView;
import com.google.android.gms.ads.LoadAdError;
import com.google.android.gms.ads.MobileAds;
import com.google.android.gms.ads.formats.MediaView;
import com.google.android.material.appbar.AppBarLayout;
import com.google.android.material.floatingactionbutton.FloatingActionButton;
import com.google.android.material.navigation.NavigationView;
import com.google.android.ump.ConsentDebugSettings;
import com.google.android.ump.ConsentForm;
import com.google.android.ump.ConsentInformation;
import com.google.android.ump.ConsentRequestParameters;
import com.google.android.ump.UserMessagingPlatform;
import com.h6ah4i.android.widget.verticalseekbar.VerticalSeekBar;
import com.labo.kaji.relativepopupwindow.RelativePopupWindow;
import com.makeramen.roundedimageview.RoundedImageView;
import com.makeramen.roundedimageview.RoundedTransformationBuilder;
import com.sothree.slidinguppanel.SlidingUpPanelLayout;
import com.squareup.picasso.Picasso;
import com.squareup.picasso.Transformation;
import com.startapp.sdk.ads.banner.Banner;
import com.startapp.sdk.ads.banner.BannerListener;
import com.startapp.sdk.ads.nativead.NativeAdDetails;
import com.startapp.sdk.ads.nativead.NativeAdPreferences;
import com.startapp.sdk.ads.nativead.StartAppNativeAd;
import com.startapp.sdk.adsbase.StartAppAd;
import com.startapp.sdk.adsbase.StartAppSDK;
import com.startapp.sdk.adsbase.adlisteners.AdEventListener;
import com.warkiz.widget.IndicatorSeekBar;
import com.warkiz.widget.OnSeekChangeListener;
import com.warkiz.widget.SeekParams;

import org.json.JSONException;

import java.util.ArrayList;
import java.util.List;
import java.util.Random;
import java.util.concurrent.TimeUnit;

import es.claucookie.miniequalizerlibrary.EqualizerView;
import jp.wasabeef.picasso.transformations.BlurTransformation;

import static com.app.yourradioapp.Config.USE_LEGACY_GDPR_EU_CONSENT;
import static com.app.yourradioapp.utils.Constant.ADMOB;
import static com.app.yourradioapp.utils.Constant.AD_STATUS_ON;
import static com.app.yourradioapp.utils.Constant.FAN;
import static com.app.yourradioapp.utils.Constant.STARTAPP;
import static com.app.yourradioapp.utils.Constant.STARTAPP_IMAGE_LARGE;
import static com.app.yourradioapp.utils.Constant.STARTAPP_IMAGE_XSMALL;
import static com.app.yourradioapp.utils.Constant.THEME_DARK;
import static com.app.yourradioapp.utils.Constant.THEME_LIGHT;
import static com.app.yourradioapp.utils.Constant.THEME_PRIMARY;

public class MainActivity extends AppCompatActivity implements NavigationView.OnNavigationItemSelectedListener {

    private final static String COLLAPSING_TOOLBAR_FRAGMENT_TAG = "";
    private final static String SELECTED_TAG = "selected_index";
    private static int selectedIndex;
    private final static int COLLAPSING_TOOLBAR = 0;
    ActionBarDrawerToggle actionBarDrawerToggle;
    private DrawerLayout drawerLayout;
    NavigationView navigationView;
    SlidingUpPanelLayout slidingUpPanelLayout;
    ProgressBar progressBar, progressBarCollapse;
    SeekBar seek_bar_song;
    LinearLayout lyt_collapse_color, lyt_player_expand, lyt_play_collapse;
    RelativeLayout lyt_expand, lyt_collapse, lyt_seek_bar;
    RoundedImageView img_player;
    ImageView img_radio;
    ImageView img_music_background;
    ImageButton img_next_expand, img_previous_expand, img_volume, img_favorite;
    ImageButton img_collapse, img_timer, img_share;
    ImageButton img_play, img_next, img_previous;
    FloatingActionButton fab_play_expand;
    TextView txt_name, txt_song, txt_radio_expand, txt_radio_music_song, txt_song_expand, txt_duration, txt_total_duration;
    Boolean isExpand = false;
    SharedPref sharedPref;
    final int PERMISSIONS_REQUEST_WRITE_EXTERNAL_STORAGE = 102;
    private Handler seekHandler = new Handler();
    Handler handler = new Handler();
    StatusBarView statusBarView;
    FragmentManager fragmentManager;
    EqualizerView equalizerView;
    private FrameLayout adContainerView;
    private AdView adView;
    com.facebook.ads.AdView fanAdView;
    private StartAppNativeAd startAppNativeAd;
    private NativeAdDetails nativeAd = null;
    View lyt_music_screen;
    Boolean isCancelled = false;
    long id = 0;
    String page_url = "";
    DatabaseHandler databaseHandler;
    Tools tools;
    AdsPref adsPref;
    private ConsentInformation consentInformation;
    private ConsentForm consentForm;
    ThemePref themePref;
    private AlertDialog.Builder alert;
    private AlertDialog dialog;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        Tools.getTheme(this);
        adsPref = new AdsPref(this);
        if (adsPref.getAdStatus().equals(AD_STATUS_ON) && adsPref.getAdType().equals(STARTAPP)) {
            StartAppSDK.init(MainActivity.this, adsPref.getStartappAppID(), false);
            //StartAppSDK.setTestAdsEnabled(BuildConfig.DEBUG);
        }
        setContentView(R.layout.activity_main);

        themePref = new ThemePref(this);

        if (Config.ENABLE_RTL_MODE) {
            if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.JELLY_BEAN_MR1) {
                getWindow().getDecorView().setLayoutDirection(View.LAYOUT_DIRECTION_RTL);
            }
        }

        if (adsPref.getAdStatus().equals(AD_STATUS_ON) && adsPref.getAdType().equals(STARTAPP)) {
            StartAppSDK.setUserConsent(this, "pas", System.currentTimeMillis(), true);
            StartAppAd.disableSplash();
        }

        if (adsPref.getAdStatus().equals(AD_STATUS_ON) && adsPref.getAdType().equals(ADMOB)) {
            MobileAds.initialize(this, initializationStatus -> {
            });
            if (USE_LEGACY_GDPR_EU_CONSENT) {
                GDPR.updateConsentStatus(this);
            } else {
                updateConsentStatus();
            }
        }

        AppBarLayout appBarLayout = findViewById(R.id.tab_appbar_layout);
        ((CoordinatorLayout.LayoutParams) appBarLayout.getLayoutParams()).setBehavior(new AppBarLayoutBehavior());

        Constant.is_app_open = true;

        databaseHandler = new DatabaseHandler(this);
        sharedPref = new SharedPref(this);
        sharedPref.setCheckSleepTime();
        tools = new Tools(this);

        navigationView = findViewById(R.id.navigation_view);
        navigationView.setNavigationItemSelectedListener(this);

        View view = navigationView.getHeaderView(0);
        drawerLayout = findViewById(R.id.drawer_layout);

        if (savedInstanceState != null) {
            navigationView.getMenu().getItem(savedInstanceState.getInt(SELECTED_TAG)).setChecked(true);
            return;
        }

        selectedIndex = COLLAPSING_TOOLBAR;
        getSupportFragmentManager().beginTransaction()
                .add(R.id.fragment_container, new FragmentTabLayout(), COLLAPSING_TOOLBAR_FRAGMENT_TAG)
                .commit();

        statusBarView = findViewById(R.id.statusBar);

        initComponent();
        initAdNetwork();
        pushNotificationHandler();
        //validate();

        themeColor();

    }

    public void pushNotificationHandler() {

        if (getIntent().hasExtra("nid")) {
            id = getIntent().getLongExtra("nid", 0);
            page_url = getIntent().getStringExtra("external_link");
        }

        new Handler().postDelayed(() -> {
            if (!isCancelled) {
                if (id == 0) {
                    if (page_url.equals("") || page_url.equals("no_url")) {
                        Log.d("NOTIF", "do nothing");
                    } else {
                        if (Config.OPEN_NOTIFICATION_LINK_IN_EXTERNAL_BROWSER) {
                            startActivity(new Intent(Intent.ACTION_VIEW, Uri.parse(page_url.trim())));
                        } else {
                            Intent intent = new Intent(getApplicationContext(), ActivityWebView.class);
                            intent.putExtra("url", page_url);
                            startActivity(intent);
                        }
                    }
                }
            }
        }, 100);

    }

    public void initComponent() {

        fragmentManager = getSupportFragmentManager();
        slidingUpPanelLayout = findViewById(R.id.sliding_layout);
        lyt_music_screen = findViewById(R.id.layout_music_player);
        img_music_background = findViewById(R.id.img_music_background);

        equalizerView = findViewById(R.id.equalizer_view);
        progressBar = findViewById(R.id.progress_bar);
        progressBarCollapse = findViewById(R.id.progress_bar_collapse);
        seek_bar_song = findViewById(R.id.seek_bar_song);
        img_share = findViewById(R.id.img_share);
        img_timer = findViewById(R.id.img_timer);
        img_player = findViewById(R.id.img_cover_small);
        img_previous = findViewById(R.id.img_player_previous);
        img_previous_expand = findViewById(R.id.img_previous_expand);
        img_next = findViewById(R.id.img_player_next);
        img_next_expand = findViewById(R.id.img_next_expand);
        img_play = findViewById(R.id.img_player_play);
        img_favorite = findViewById(R.id.img_favorite);
        img_volume = findViewById(R.id.img_volume);
        img_collapse = findViewById(R.id.img_collapse);
        txt_name = findViewById(R.id.txt_radio_name);
        txt_song = findViewById(R.id.txt_metadata);
        fab_play_expand = findViewById(R.id.fab_play);
        img_radio = findViewById(R.id.img_cover_large);
        txt_radio_expand = findViewById(R.id.txt_radio_name_expand);
        txt_radio_music_song = findViewById(R.id.txt_radio_music_expand);
        txt_song_expand = findViewById(R.id.txt_metadata_expand);
        txt_duration = findViewById(R.id.txt_song_duration);
        txt_total_duration = findViewById(R.id.txt_total_duration);

        lyt_player_expand = findViewById(R.id.lyt_player_expand);
        lyt_play_collapse = findViewById(R.id.lyt_play_collapse);
        lyt_seek_bar = findViewById(R.id.lyt_song_seek_bar);
        lyt_collapse = findViewById(R.id.lyt_collapse);
        lyt_collapse_color = findViewById(R.id.lyt_collapse_color);
        lyt_expand = findViewById(R.id.ll_expand);
        lyt_expand.setAlpha(0.0f);

        if (!tools.isNetworkAvailable()) {
            txt_name.setText(getResources().getString(R.string.app_name));
            txt_radio_expand.setText(getResources().getString(R.string.app_name));
            txt_song.setText(getResources().getString(R.string.internet_not_connected));
            txt_song_expand.setText(getResources().getString(R.string.internet_not_connected));
            lyt_seek_bar.setVisibility(View.GONE);
        }

        setIfPlaying();

        seek_bar_song.setOnSeekBarChangeListener(new SeekBar.OnSeekBarChangeListener() {

            @Override
            public void onProgressChanged(SeekBar seekBar, int progress, boolean fromUser) {
            }

            @Override
            public void onStartTrackingTouch(SeekBar seekBar) {
            }

            @Override
            public void onStopTrackingTouch(SeekBar seekBar) {
                int progress = seekBar.getProgress();
                try {
                    Constant.simpleExoPlayer.seekTo((int) Tools.getSeekFromPercentage(progress, Tools.calculateTime(Constant.item_radio.get(Constant.position).getDuration())));
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
        });

        lyt_collapse.setOnClickListener(v -> slidingUpPanelLayout.setPanelState(SlidingUpPanelLayout.PanelState.EXPANDED));

        lyt_expand.setOnClickListener(v -> {

        });

        slidingUpPanelLayout.setDragView(lyt_collapse);
        slidingUpPanelLayout.setShadowHeight(0);
        slidingUpPanelLayout.addPanelSlideListener(new SlidingUpPanelLayout.PanelSlideListener() {
            @Override
            public void onPanelSlide(View panel, float slideOffset) {
                if (slideOffset == 0.0f) {
                    isExpand = false;
                    lyt_expand.setVisibility(View.GONE);
                } else if (slideOffset > 0.0f && slideOffset < 1.0f) {
                    if (isExpand) {
                        lyt_collapse.setVisibility(View.VISIBLE);
                        lyt_expand.setAlpha(slideOffset);
                        lyt_collapse.setAlpha(1.0f - slideOffset);
                    } else {
                        lyt_expand.setVisibility(View.VISIBLE);
                        lyt_expand.setAlpha(0.0f + slideOffset);
                        lyt_collapse.setAlpha(1.0f - slideOffset);
                    }
                } else {
                    isExpand = true;
                    lyt_collapse.setVisibility(View.GONE);
                }
            }

            @Override
            public void onPanelStateChanged(View panel, SlidingUpPanelLayout.PanelState previousState, SlidingUpPanelLayout.PanelState newState) {
                if (newState == SlidingUpPanelLayout.PanelState.EXPANDED) {
                    Log.d("INFO", "Do nothing");
                }
            }
        });

        img_play.setOnClickListener(view -> {
            if (!tools.isNetworkAvailable()) {
                Toast.makeText(MainActivity.this, getResources().getString(R.string.internet_not_connected), Toast.LENGTH_SHORT).show();
            } else if (txt_name.getText().equals(getString(R.string.app_name))) {
                Toast.makeText(MainActivity.this, getResources().getString(R.string.no_radio_selected), Toast.LENGTH_SHORT).show();
            } else {
                clickPlay(Constant.position, Constant.radio_type);
            }
        });

        fab_play_expand.setOnClickListener(view -> {
            if (!tools.isNetworkAvailable()) {
                Toast.makeText(MainActivity.this, getResources().getString(R.string.internet_not_connected), Toast.LENGTH_SHORT).show();
            } else if (txt_name.getText().equals(getString(R.string.app_name))) {
                Toast.makeText(MainActivity.this, getResources().getString(R.string.no_radio_selected), Toast.LENGTH_SHORT).show();
            } else {
                clickPlay(Constant.position, Constant.radio_type);
            }
        });

        img_next.setOnClickListener(view -> togglePlayPosition(true));

        img_next_expand.setOnClickListener(view -> togglePlayPosition(true));

        img_previous.setOnClickListener(view -> togglePlayPosition(false));

        img_previous_expand.setOnClickListener(view -> togglePlayPosition(false));

        img_timer.setOnClickListener(v -> {
            if (sharedPref.getIsSleepTimeOn()) {
                openTimeDialog();
            } else {
                openTimeSelectDialog();
            }
        });

        img_share.setOnClickListener(v -> {
            if (Constant.item_radio.size() > 0) {
                Intent share = new Intent(Intent.ACTION_SEND);
                share.setType("text/plain");
                share.putExtra(Intent.EXTRA_TEXT, getString(R.string.share_radio_text) + " - " + Constant.item_radio.get(Constant.position).getRadio_name() + "\n" + getString(R.string.app_name) + " - http://play.google.com/store/apps/details?id=" + getPackageName());
                startActivity(share);
            }
        });

        img_collapse.setOnClickListener(v -> slidingUpPanelLayout.setPanelState(SlidingUpPanelLayout.PanelState.COLLAPSED));

        img_volume.setOnClickListener(v -> changeVolume());

        img_favorite.setOnClickListener(view -> {
            if (tools.isNetworkAvailable()) {
                List<ItemRadio> data = databaseHandler.getFavRow(Constant.item_radio.get(Constant.position).getRadio_id());
                if (data.size() == 0) {
                    databaseHandler.AddtoFavorite(new ItemRadio(
                            Constant.item_radio.get(Constant.position).getRadio_id(),
                            Constant.item_radio.get(Constant.position).getRadio_name(),
                            Constant.item_radio.get(Constant.position).getRadio_image(),
                            Constant.item_radio.get(Constant.position).getRadio_url(),
                            Constant.item_radio.get(Constant.position).getCategory_name()));
                    Toast.makeText(getApplicationContext(), getString(R.string.favorite_added), Toast.LENGTH_SHORT).show();
                    img_favorite.setImageDrawable(ContextCompat.getDrawable(MainActivity.this, R.drawable.ic_star_white));
                } else {
                    if (data.get(0).getRadio_id().equals(Constant.item_radio.get(Constant.position).getRadio_id())) {
                        databaseHandler.RemoveFav(new ItemRadio(Constant.item_radio.get(Constant.position).getRadio_id()));
                        Toast.makeText(getApplicationContext(), getString(R.string.favorite_removed), Toast.LENGTH_SHORT).show();
                        img_favorite.setImageDrawable(ContextCompat.getDrawable(MainActivity.this, R.drawable.ic_star_outline));
                    }
                }
            }
        });

        checkPermission();

    }

    @Override
    protected void onSaveInstanceState(@NonNull Bundle outState) {
        super.onSaveInstanceState(outState);
        outState.putInt(SELECTED_TAG, selectedIndex);
    }

    @Override
    public boolean onNavigationItemSelected(@NonNull MenuItem menuItem) {

        switch (menuItem.getItemId()) {

            case R.id.drawer_recent:

                FragmentTabLayout ft1 = new FragmentTabLayout();
                loadFrag(ft1, fragmentManager);

                drawerLayout.closeDrawer(GravityCompat.START);
                hideKeyboard();

                return true;

            case R.id.drawer_social:

                if (!menuItem.isChecked()) {
                    menuItem.setChecked(true);
                    FragmentSocial ft = new FragmentSocial();
                    loadFrag(ft, fragmentManager);
                }
                drawerLayout.closeDrawer(GravityCompat.START);
                hideKeyboard();

                return true;

            case R.id.drawer_settings:

                if (!menuItem.isChecked()) {
                    menuItem.setChecked(true);
                    menuItem.setChecked(true);
                    FragmentSettings ft = new FragmentSettings();
                    loadFrag(ft, fragmentManager);
                }
                drawerLayout.closeDrawer(GravityCompat.START);
                hideKeyboard();

                return true;

            case R.id.drawer_about:
                aboutDialog();
                drawerLayout.closeDrawer(GravityCompat.START);
                hideKeyboard();

                return true;

        }
        return false;
    }

    public void setupNavigationDrawer(Toolbar toolbar) {
        actionBarDrawerToggle = new ActionBarDrawerToggle(this, drawerLayout, toolbar, R.string.drawer_open, R.string.drawer_close) {
            @Override
            public void onDrawerOpened(View drawerView) {
                super.onDrawerOpened(drawerView);
            }

            @Override
            public void onDrawerClosed(View drawerView) {
                super.onDrawerClosed(drawerView);
            }
        };

        if (themePref.getCurrentTheme() == THEME_LIGHT) {
            actionBarDrawerToggle.getDrawerArrowDrawable().setColor(getResources().getColor(R.color.grey));
        } else if (themePref.getCurrentTheme() == THEME_DARK) {
            actionBarDrawerToggle.getDrawerArrowDrawable().setColor(getResources().getColor(R.color.colorLight));
        } else if (themePref.getCurrentTheme() == THEME_PRIMARY) {
            actionBarDrawerToggle.getDrawerArrowDrawable().setColor(getResources().getColor(R.color.colorLight));
        }

        drawerLayout.addDrawerListener(actionBarDrawerToggle);
        actionBarDrawerToggle.syncState();
    }

    public void loadFrag(Fragment f1, FragmentManager fm) {
        for (int i = 0; i < fm.getBackStackEntryCount(); ++i) {
            fm.popBackStack();
        }
        FragmentTransaction ft = fm.beginTransaction();
        ft.setTransition(FragmentTransaction.TRANSIT_FRAGMENT_OPEN);
        ft.replace(R.id.fragment_container, f1);
        ft.commit();
    }

    private void togglePlayPosition(Boolean isNext) {
        if (Constant.item_radio.size() > 0) {
            if (RadioPlayerService.getInstance() == null) {
                RadioPlayerService.createInstance().initialize(MainActivity.this, Constant.item_radio.get(Constant.position));
            }
            Intent intent;
            intent = new Intent(MainActivity.this, RadioPlayerService.class);
            if (isNext) {
                intent.setAction(RadioPlayerService.ACTION_NEXT);
            } else {
                intent.setAction(RadioPlayerService.ACTION_PREVIOUS);
            }
            startService(intent);
        }
    }

    public void clickPlay(int position, Boolean isRadio) {
        Constant.radio_type = isRadio;
        Constant.position = position;
        ItemRadio radio = Constant.item_radio.get(Constant.position);
        final Intent intent = new Intent(MainActivity.this, RadioPlayerService.class);

        if (RadioPlayerService.getInstance() != null) {
            ItemRadio playerCurrentRadio = RadioPlayerService.getInstance().getPlayingRadioStation();
            if (playerCurrentRadio != null) {
                if (!radio.getRadio_id().equals(RadioPlayerService.getInstance().getPlayingRadioStation().getRadio_id())) {
                    RadioPlayerService.getInstance().initialize(MainActivity.this, radio);
                    intent.setAction(RadioPlayerService.ACTION_PLAY);
                } else {
                    intent.setAction(RadioPlayerService.ACTION_TOGGLE);
                }
            } else {
                RadioPlayerService.getInstance().initialize(MainActivity.this, radio);
                intent.setAction(RadioPlayerService.ACTION_PLAY);
            }
        } else {
            RadioPlayerService.createInstance().initialize(MainActivity.this, radio);
            intent.setAction(RadioPlayerService.ACTION_PLAY);
        }
        startService(intent);
    }

    public void changePlayPause(Boolean flag) {
        Constant.is_playing = flag;
        if (flag) {
            ItemRadio itemRadio = RadioPlayerService.getInstance().getPlayingRadioStation();
            if (itemRadio != null) {
                changeText(itemRadio);
                changeFav(itemRadio);
                img_play.setImageDrawable(ContextCompat.getDrawable(MainActivity.this, R.drawable.ic_pause_white));
                fab_play_expand.setImageDrawable(ContextCompat.getDrawable(MainActivity.this, R.drawable.ic_pause_white));
                equalizerView.animateBars();
            }
        } else {
            if (Constant.item_radio.size() > 0) {
                changeText(Constant.item_radio.get(Constant.position));
                changeFav(Constant.item_radio.get(Constant.position));
            }
            img_play.setImageDrawable(ContextCompat.getDrawable(MainActivity.this, R.drawable.ic_play_arrow_white));
            fab_play_expand.setImageDrawable(ContextCompat.getDrawable(MainActivity.this, R.drawable.ic_play_arrow_white));
            equalizerView.stopBars();
        }
    }

    public void changeFav(ItemRadio itemRadio) {
        checkFav(itemRadio.getRadio_id());
    }

    public void checkFav(String id) {
        if (databaseHandler.checkFav(id)) {
            img_favorite.setImageDrawable(ContextCompat.getDrawable(MainActivity.this, R.drawable.ic_star_white));
        } else {
            img_favorite.setImageDrawable(ContextCompat.getDrawable(MainActivity.this, R.drawable.ic_star_outline));
        }
    }

    public void changeText(ItemRadio itemRadio) {
        if (Constant.radio_type) {
            changeSongName(Constant.metadata);
            txt_song_expand.setVisibility(View.VISIBLE);
            img_timer.setVisibility(View.VISIBLE);
            lyt_seek_bar.setVisibility(View.GONE);

            if (FragmentRadio.adapterRadio != null) {
                FragmentRadio.adapterRadio.notifyDataSetChanged();
            }
        } else {
            txt_total_duration.setText(itemRadio.getDuration());
            txt_radio_music_song.setText("");
            txt_song.setText("");
            txt_song_expand.setText(itemRadio.getRadio_name());
            txt_song_expand.setVisibility(View.INVISIBLE);
            img_timer.setVisibility(View.GONE);
            lyt_seek_bar.setVisibility(View.VISIBLE);
        }
        txt_name.setText(itemRadio.getRadio_name());
        txt_radio_expand.setText(itemRadio.getRadio_name());

        if (!Constant.is_playing) {
            txt_song.setText(itemRadio.getCategory_name());
            txt_song_expand.setText(itemRadio.getCategory_name());
        }

        Transformation roundedImageView = new RoundedTransformationBuilder()
                .cornerRadiusDp(8)
                .oval(false)
                .build();

        Picasso.with(this).load(Config.ADMIN_PANEL_URL + "/upload/" + itemRadio.getRadio_image())
                .transform(new BlurTransformation(this, 25, 1))
                .placeholder(R.drawable.ic_artwork)
                .into(img_music_background);

        Picasso.with(this).load(Config.ADMIN_PANEL_URL + "/upload/" + itemRadio.getRadio_image())
                .placeholder(R.drawable.ic_artwork)
                .transform(roundedImageView)
                .into(img_radio);

        Picasso.with(this).load(Config.ADMIN_PANEL_URL + "/upload/" + itemRadio.getRadio_image())
                .placeholder(R.drawable.ic_artwork)
                .resizeDimen(R.dimen.img_row_radio, R.dimen.img_row_radio)
                .centerCrop()
                .into(img_player);
    }

    public void changeSongName(String songName) {
        Constant.metadata = songName;
        txt_song.setText(songName);
        txt_song_expand.setText(songName);
    }

    public void setIfPlaying() {
        if (RadioPlayerService.getInstance() != null) {
            RadioPlayerService.initNewContext(MainActivity.this);
            changePlayPause(RadioPlayerService.getInstance().isPlaying());
            seekBarUpdate();
        } else {
            changePlayPause(false);
        }
    }

    public void checkPermission() {
        if ((ContextCompat.checkSelfPermission(MainActivity.this, "android.permission.WRITE_EXTERNAL_STORAGE") != PackageManager.PERMISSION_GRANTED) && (ContextCompat.checkSelfPermission(MainActivity.this, "android.permission.READ_PHONE_STATE") != PackageManager.PERMISSION_GRANTED)) {
            if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.M) {
                requestPermissions(new String[]{"android.permission.WRITE_EXTERNAL_STORAGE", "android.permission.READ_PHONE_STATE"}, 1);
            }
        }
    }

    @Override
    public void onRequestPermissionsResult(int requestCode, @NonNull String[] permissions, @NonNull int[] grantResults) {
        switch (requestCode) {
            case PERMISSIONS_REQUEST_WRITE_EXTERNAL_STORAGE: {
                if (grantResults.length > 0 && grantResults[0] == PackageManager.PERMISSION_GRANTED) {
                }
            }
        }
    }

    private Runnable run = () -> {
        try {
            seekBarUpdate();
        } catch (Exception e) {
            e.printStackTrace();
        }
    };

    public void seekBarUpdate() {
        try {
            if (!Constant.radio_type && Constant.is_app_open) {
                seek_bar_song.setProgress(Tools.getProgressPercentage(Constant.simpleExoPlayer.getCurrentPosition(), Tools.calculateTime(Constant.item_radio.get(Constant.position).getDuration())));
                txt_duration.setText(Tools.milliSecondsToTimer(Constant.simpleExoPlayer.getCurrentPosition()));
                Log.e("duration", "" + Tools.milliSecondsToTimer(Constant.simpleExoPlayer.getCurrentPosition()));
                seek_bar_song.setSecondaryProgress(Constant.simpleExoPlayer.getBufferedPercentage());
                if (RadioPlayerService.getInstance().isPlaying()) {
                    seekHandler.removeCallbacks(run);
                    seekHandler.postDelayed(run, 1000);
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void setBuffer(Boolean flag) {
        if (flag) {
            progressBar.setVisibility(View.VISIBLE);
            lyt_player_expand.setVisibility(View.INVISIBLE);
            progressBarCollapse.setVisibility(View.VISIBLE);
            lyt_play_collapse.setVisibility(View.INVISIBLE);
        } else {
            progressBar.setVisibility(View.INVISIBLE);
            lyt_player_expand.setVisibility(View.VISIBLE);
            progressBarCollapse.setVisibility(View.INVISIBLE);
            lyt_play_collapse.setVisibility(View.VISIBLE);
        }
    }

    public void changeVolume() {
        final RelativePopupWindow popupWindow = new RelativePopupWindow(this);
        LayoutInflater inflater = (LayoutInflater) getSystemService(Context.LAYOUT_INFLATER_SERVICE);

        assert inflater != null;
        @SuppressLint("InflateParams") View view = inflater.inflate(R.layout.lyt_volume, null);
        ImageView imageView1 = view.findViewById(R.id.img_volume_max);
        ImageView imageView2 = view.findViewById(R.id.img_volume_min);
        imageView1.setColorFilter(Color.BLACK);
        imageView2.setColorFilter(Color.BLACK);

        VerticalSeekBar seekBar = view.findViewById(R.id.seek_bar_volume);
        seekBar.getThumb().setColorFilter(sharedPref.getFirstColor(), PorterDuff.Mode.SRC_IN);
        seekBar.getProgressDrawable().setColorFilter(sharedPref.getSecondColor(), PorterDuff.Mode.SRC_IN);

        final AudioManager am = (AudioManager) getSystemService(Context.AUDIO_SERVICE);
        assert am != null;
        seekBar.setMax(am.getStreamMaxVolume(AudioManager.STREAM_MUSIC));
        int volume_level = am.getStreamVolume(AudioManager.STREAM_MUSIC);
        seekBar.setProgress(volume_level);
        seekBar.setOnSeekBarChangeListener(new SeekBar.OnSeekBarChangeListener() {
            @Override
            public void onProgressChanged(SeekBar seekBar, int i, boolean b) {
                am.setStreamVolume(AudioManager.STREAM_MUSIC, i, 0);
            }

            @Override
            public void onStartTrackingTouch(SeekBar seekBar) {

            }

            @Override
            public void onStopTrackingTouch(SeekBar seekBar) {

            }
        });

        popupWindow.setFocusable(true);
        popupWindow.setWidth(WindowManager.LayoutParams.WRAP_CONTENT);
        popupWindow.setHeight(WindowManager.LayoutParams.WRAP_CONTENT);
        popupWindow.setBackgroundDrawable(new ColorDrawable(android.graphics.Color.TRANSPARENT));
        popupWindow.setContentView(view);
        popupWindow.showOnAnchor(img_volume, RelativePopupWindow.VerticalPosition.ABOVE, RelativePopupWindow.HorizontalPosition.CENTER);
    }

    public void openTimeSelectDialog() {
        AlertDialog.Builder alt_bld = new AlertDialog.Builder(this);
        alt_bld.setTitle(getString(R.string.sleep_time));

        LayoutInflater inflater = this.getLayoutInflater();
        View dialogView = inflater.inflate(R.layout.lyt_dialog_select_time, null);
        alt_bld.setView(dialogView);

        final TextView tv_min = dialogView.findViewById(R.id.txt_minutes);
        tv_min.setText("1 " + getString(R.string.min));
        FrameLayout frameLayout = dialogView.findViewById(R.id.frameLayout);

        final IndicatorSeekBar seekbar = IndicatorSeekBar
                .with(MainActivity.this)
                .min(1)
                .max(120)
                .progress(1)
                .thumbColor(sharedPref.getSecondColor())
                .indicatorColor(sharedPref.getFirstColor())
                .trackProgressColor(sharedPref.getFirstColor())
                .build();

        seekbar.setOnSeekChangeListener(new OnSeekChangeListener() {
            @Override
            public void onSeeking(SeekParams seekParams) {
                tv_min.setText(seekParams.progress + " " + getString(R.string.min));
            }

            @Override
            public void onStartTrackingTouch(IndicatorSeekBar seekBar) {

            }

            @Override
            public void onStopTrackingTouch(IndicatorSeekBar seekBar) {

            }
        });

        frameLayout.addView(seekbar);

        alt_bld.setPositiveButton(getString(R.string.set), (dialog, which) -> {
            String hours = String.valueOf(seekbar.getProgress() / 60);
            String minute = String.valueOf(seekbar.getProgress() % 60);

            if (hours.length() == 1) {
                hours = "0" + hours;
            }

            if (minute.length() == 1) {
                minute = "0" + minute;
            }

            String totalTime = hours + ":" + minute;
            long total_timer = tools.convertToMilliSeconds(totalTime) + System.currentTimeMillis();

            Random random = new Random();
            int id = random.nextInt(100);

            sharedPref.setSleepTime(true, total_timer, id);

            Intent intent = new Intent(MainActivity.this, SleepTimeReceiver.class);
            PendingIntent pendingIntent = PendingIntent.getBroadcast(getApplicationContext(), id, intent, PendingIntent.FLAG_ONE_SHOT);
            AlarmManager alarmManager = (AlarmManager) getSystemService(ALARM_SERVICE);
            if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.KITKAT) {
                assert alarmManager != null;
                alarmManager.setExact(AlarmManager.RTC_WAKEUP, total_timer, pendingIntent);
            } else {
                assert alarmManager != null;
                alarmManager.set(AlarmManager.RTC_WAKEUP, total_timer, pendingIntent);
            }
        });
        alt_bld.setNegativeButton(getString(R.string.cancel), (dialog, which) -> {

        });
        AlertDialog alert = alt_bld.create();
        alert.show();
    }

    public void openTimeDialog() {
        AlertDialog.Builder builder = new AlertDialog.Builder(MainActivity.this);
        builder.setTitle(getString(R.string.sleep_time));
        LayoutInflater inflater = this.getLayoutInflater();
        View dialogView = inflater.inflate(R.layout.lyt_dialog_time, null);
        builder.setView(dialogView);

        TextView textView = dialogView.findViewById(R.id.txt_time);

        builder.setNegativeButton(getString(R.string.cancel), (dialog, which) -> {

        });

        builder.setPositiveButton(getString(R.string.stop), (dialog, which) -> {
            Intent i = new Intent(MainActivity.this, SleepTimeReceiver.class);
            PendingIntent pendingIntent = PendingIntent.getBroadcast(MainActivity.this, sharedPref.getSleepID(), i, PendingIntent.FLAG_ONE_SHOT);
            AlarmManager alarmManager = (AlarmManager) getSystemService(Context.ALARM_SERVICE);
            pendingIntent.cancel();
            assert alarmManager != null;
            alarmManager.cancel(pendingIntent);
            sharedPref.setSleepTime(false, 0, 0);
        });

        updateTimer(textView, sharedPref.getSleepTime());

        builder.show();
    }

    private void updateTimer(final TextView textView, long time) {
        long timeleft = time - System.currentTimeMillis();
        if (timeleft > 0) {
            @SuppressLint("DefaultLocale") String hms = String.format("%02d:%02d:%02d", TimeUnit.MILLISECONDS.toHours(timeleft),
                    TimeUnit.MILLISECONDS.toMinutes(timeleft) % TimeUnit.HOURS.toMinutes(1),
                    TimeUnit.MILLISECONDS.toSeconds(timeleft) % TimeUnit.MINUTES.toSeconds(1));

            textView.setText(hms);
            handler.postDelayed(() -> {
                if (sharedPref.getIsSleepTimeOn()) {
                    updateTimer(textView, sharedPref.getSleepTime());
                }
            }, 1000);
        }
    }

    private void validate() {

        JsonObjectRequest jsonObjReq = new JsonObjectRequest(Request.Method.GET, Constant.URL_PACKAGE_NAME, null, response -> {

            try {
                final String package_name = response.getString("package_name");
                if (BuildConfig.APPLICATION_ID.equals(package_name)) {
                    Log.d("PACKAGE_NAME", "Package Name Validated : " + package_name);
                } else {
                    AlertDialog.Builder dialog = new AlertDialog.Builder(MainActivity.this);
                    dialog.setTitle(getResources().getString(R.string.msg_oops));
                    dialog.setMessage(getResources().getString(R.string.msg_validate));
                    dialog.setPositiveButton(getResources().getString(R.string.option_ok), (dialogInterface, i) -> finish());
                    dialog.setCancelable(false);
                    dialog.show();
                    Log.d("PACKAGE_NAME", "Package Name Refused");
                }

            } catch (JSONException e) {
                e.printStackTrace();
                Log.d("INFO", "Do Nothing");
            }
        }, error -> Log.d("INFO", "Do Nothing"));

        MyApplication.getInstance().addToRequestQueue(jsonObjReq);
    }

    @Override
    public void onBackPressed() {
        if (drawerLayout.isDrawerOpen(GravityCompat.START)) {
            drawerLayout.closeDrawer(GravityCompat.START);
        } else if (slidingUpPanelLayout.getPanelState() == SlidingUpPanelLayout.PanelState.EXPANDED) {
            slidingUpPanelLayout.setPanelState(SlidingUpPanelLayout.PanelState.COLLAPSED);
        } else if (fragmentManager.getBackStackEntryCount() != 0) {
            final ActionBar actionBar = getSupportActionBar();
            if (actionBar != null) {
                getSupportActionBar().setTitle(fragmentManager.getFragments().get(fragmentManager.getBackStackEntryCount() - 1).getTag());
                super.onBackPressed();
            }
        } else {
            exitDialog();
        }
    }

    public void exitDialog() {

        if (adsPref.getAdStatus().equals(AD_STATUS_ON)) {
            LayoutInflater inflater = LayoutInflater.from(this);
            View view = inflater.inflate(R.layout.custom_exit_dialog, null);
            TemplateView native_template = view.findViewById(R.id.my_template);
            MediaView mediaView = view.findViewById(R.id.media_view);

            if (adsPref.getAdStatus().equals(AD_STATUS_ON) && adsPref.getAdType().equals(ADMOB)) {
                if (!adsPref.getAdMobNativeId().equals("0")) {
                    AdLoader adLoader = new AdLoader.Builder(this, adsPref.getAdMobNativeId())
                            .forUnifiedNativeAd(unifiedNativeAd -> {
                                if (themePref.getCurrentTheme() == THEME_LIGHT || themePref.getCurrentTheme() == THEME_PRIMARY) {
                                    ColorDrawable colorDrawable = new ColorDrawable(ContextCompat.getColor(this, R.color.colorLight));
                                    NativeTemplateStyle styles = new NativeTemplateStyle.Builder().withMainBackgroundColor(colorDrawable).build();
                                    native_template.setStyles(styles);
                                } else if (themePref.getCurrentTheme() == THEME_DARK) {
                                    ColorDrawable colorDrawable = new ColorDrawable(ContextCompat.getColor(this, R.color.dark_dialog));
                                    NativeTemplateStyle styles = new NativeTemplateStyle.Builder().withMainBackgroundColor(colorDrawable).build();
                                    native_template.setStyles(styles);
                                }
                                mediaView.setImageScaleType(ImageView.ScaleType.CENTER_CROP);
                                native_template.setNativeAd(unifiedNativeAd);
                                native_template.setVisibility(View.VISIBLE);
                            })
                            .withAdListener(new AdListener() {
                                @Override
                                public void onAdFailedToLoad(LoadAdError adError) {
                                    native_template.setVisibility(View.GONE);
                                }
                            })
                            .build();
                    adLoader.loadAd(Tools.getAdRequest(this));
                }
            } else if (adsPref.getAdStatus().equals(AD_STATUS_ON) && adsPref.getAdType().equals(FAN)) {
                if (!adsPref.getFanNativeUnitId().equals("0")) {
                    final NativeAd nativeAd;
                    final RelativeLayout lyt_fan_native = view.findViewById(R.id.lyt_fan_native);
                    final NativeAdLayout nativeAdLayout = view.findViewById(R.id.native_ad_container);
                    if (BuildConfig.DEBUG) {
                        nativeAd = new NativeAd(this, "IMG_16_9_APP_INSTALL#" + adsPref.getFanNativeUnitId());
                    } else {
                        nativeAd = new NativeAd(this, adsPref.getFanNativeUnitId());
                    }
                    NativeAdListener nativeAdListener = new NativeAdListener() {
                        @Override
                        public void onMediaDownloaded(com.facebook.ads.Ad ad) {

                        }

                        @Override
                        public void onError(com.facebook.ads.Ad ad, AdError adError) {

                        }

                        @Override
                        public void onAdLoaded(com.facebook.ads.Ad ad) {
                            // Race condition, load() called again before last ad was displayed
                            lyt_fan_native.setVisibility(View.VISIBLE);
                            if (nativeAd != ad) {
                                return;
                            }
                            // Inflate Native Ad into Container
                            //inflateAd(nativeAd);
                            nativeAd.unregisterView();
                            // Add the Ad view into the ad container.
                            LayoutInflater inflater = LayoutInflater.from(getApplicationContext());
                            // Inflate the Ad view.  The layout referenced should be the one you created in the last step.
                            LinearLayout nativeAdView = (LinearLayout) inflater.inflate(R.layout.gnt_fan_medium_template, nativeAdLayout, false);
                            nativeAdLayout.addView(nativeAdView);

                            // Add the AdOptionsView
                            LinearLayout adChoicesContainer = nativeAdView.findViewById(R.id.ad_choices_container);
                            AdOptionsView adOptionsView = new AdOptionsView(getApplicationContext(), nativeAd, nativeAdLayout);
                            adChoicesContainer.removeAllViews();
                            adChoicesContainer.addView(adOptionsView, 0);

                            // Create native UI using the ad metadata.
                            TextView nativeAdTitle = nativeAdView.findViewById(R.id.native_ad_title);
                            com.facebook.ads.MediaView nativeAdMedia = nativeAdView.findViewById(R.id.native_ad_media);
                            TextView nativeAdSocialContext = nativeAdView.findViewById(R.id.native_ad_social_context);
                            TextView nativeAdBody = nativeAdView.findViewById(R.id.native_ad_body);
                            TextView sponsoredLabel = nativeAdView.findViewById(R.id.native_ad_sponsored_label);
                            Button nativeAdCallToAction = nativeAdView.findViewById(R.id.native_ad_call_to_action);
                            LinearLayout ad_unit = nativeAdView.findViewById(R.id.ad_unit);

                            if (themePref.getCurrentTheme() == THEME_DARK) {
                                nativeAdTitle.setTextColor(ContextCompat.getColor(getApplicationContext(), R.color.white));
                                nativeAdSocialContext.setTextColor(ContextCompat.getColor(getApplicationContext(), R.color.white));
                                sponsoredLabel.setTextColor(ContextCompat.getColor(getApplicationContext(), R.color.textColorGrey));
                                nativeAdBody.setTextColor(ContextCompat.getColor(getApplicationContext(), R.color.textColorGrey));
                            }

                            // Set the Text.
                            nativeAdTitle.setText(nativeAd.getAdvertiserName());
                            nativeAdBody.setText(nativeAd.getAdBodyText());
                            nativeAdSocialContext.setText(nativeAd.getAdSocialContext());
                            nativeAdCallToAction.setVisibility(nativeAd.hasCallToAction() ? View.VISIBLE : View.INVISIBLE);
                            nativeAdCallToAction.setText(nativeAd.getAdCallToAction());
                            sponsoredLabel.setText(nativeAd.getSponsoredTranslation());

                            // Create a list of clickable views
                            List<View> clickableViews = new ArrayList<>();
                            clickableViews.add(nativeAdTitle);
                            clickableViews.add(ad_unit);
                            clickableViews.add(nativeAdCallToAction);

                            // Register the Title and CTA button to listen for clicks.
                            nativeAd.registerViewForInteraction(nativeAdView, nativeAdMedia, clickableViews);

                        }

                        @Override
                        public void onAdClicked(com.facebook.ads.Ad ad) {

                        }

                        @Override
                        public void onLoggingImpression(com.facebook.ads.Ad ad) {

                        }
                    };

                    NativeAd.NativeLoadAdConfig loadAdConfig = nativeAd.buildLoadAdConfig().withAdListener(nativeAdListener).build();
                    nativeAd.loadAd(loadAdConfig);
                }
            } else if (adsPref.getAdStatus().equals(AD_STATUS_ON) && adsPref.getAdType().equals(STARTAPP)) {
                if (!adsPref.getStartappAppID().equals("0")) {
                    View lyt_startapp_native = view.findViewById(R.id.startapp_native_template);
                    ImageView startapp_native_image = view.findViewById(R.id.startapp_native_image);
                    ImageView startapp_native_secondary_image = view.findViewById(R.id.startapp_native_secondary_image);
                    TextView startapp_native_title = view.findViewById(R.id.startapp_native_title);
                    TextView startapp_native_description = view.findViewById(R.id.startapp_native_description);
                    Button startapp_native_button = view.findViewById(R.id.startapp_native_button);
                    startapp_native_button.setOnClickListener(v1 -> lyt_startapp_native.performClick());

                    startAppNativeAd = new StartAppNativeAd(this);
                    NativeAdPreferences nativePrefs = new NativeAdPreferences()
                            .setAdsNumber(1)
                            .setAutoBitmapDownload(true)
                            .setPrimaryImageSize(STARTAPP_IMAGE_LARGE)
                            .setSecondaryImageSize(STARTAPP_IMAGE_XSMALL);
                    AdEventListener adListener = new AdEventListener() {
                        @Override
                        public void onReceiveAd(com.startapp.sdk.adsbase.Ad arg0) {
                            ArrayList<NativeAdDetails> nativeAdsList = startAppNativeAd.getNativeAds();
                            if (nativeAdsList.size() > 0) {
                                nativeAd = nativeAdsList.get(0);
                            }
                            if (nativeAd != null) {
                                startapp_native_image.setImageBitmap(nativeAd.getImageBitmap());
                                startapp_native_secondary_image.setImageBitmap(nativeAd.getSecondaryImageBitmap());
                                startapp_native_title.setText(nativeAd.getTitle());
                                startapp_native_description.setText(nativeAd.getDescription());
                                startapp_native_button.setText(nativeAd.isApp() ? "Install" : "Open");
                                nativeAd.registerViewForInteraction(lyt_startapp_native);
                            }
                            lyt_startapp_native.setVisibility(View.VISIBLE);
                        }

                        @Override
                        public void onFailedToReceiveAd(com.startapp.sdk.adsbase.Ad arg0) {
                            lyt_startapp_native.setVisibility(View.GONE);
                        }
                    };
                    startAppNativeAd.loadAd(nativePrefs, adListener);
                }
            }

            final AlertDialog.Builder dialog = new AlertDialog.Builder(this);
            dialog.setView(view);
            dialog.setCancelable(false);
            dialog.setPositiveButton(getResources().getString(R.string.dialog_option_quit), (dialogInterface, i) -> {
                finish();
                if (isServiceRunning()) {
                    Intent stop = new Intent(this, RadioPlayerService.class);
                    stop.setAction(RadioPlayerService.ACTION_STOP);
                    startService(stop);
                    Log.d("RADIO_SERVICE", "Service Running");
                } else {
                    Log.d("RADIO_SERVICE", "Service Not Running");
                }
            });

            dialog.setNegativeButton(getResources().getString(R.string.dialog_option_minimize), (dialogInterface, i) -> minimizeApp());

            dialog.setNeutralButton(getResources().getString(R.string.cancel), (dialogInterface, i) -> {

            });
            dialog.show();

        } else {
            AlertDialog.Builder dialog = new AlertDialog.Builder(this);
            dialog.setIcon(R.mipmap.ic_launcher);
            dialog.setTitle(R.string.app_name);
            dialog.setMessage(getResources().getString(R.string.message));
            dialog.setPositiveButton(getResources().getString(R.string.dialog_option_quit), (dialogInterface, i) -> {
                finish();
                if (isServiceRunning()) {
                    Intent stop = new Intent(MainActivity.this, RadioPlayerService.class);
                    stop.setAction(RadioPlayerService.ACTION_STOP);
                    startService(stop);
                    Log.d("RADIO_SERVICE", "Service Running");
                } else {
                    Log.d("RADIO_SERVICE", "Service Not Running");
                }
            });

            dialog.setNegativeButton(getResources().getString(R.string.dialog_option_minimize), (dialogInterface, i) -> minimizeApp());

            dialog.setNeutralButton(getResources().getString(R.string.cancel), (dialogInterface, i) -> {

            });
            dialog.show();
        }

    }

    public void minimizeApp() {
        Intent intent = new Intent(Intent.ACTION_MAIN);
        intent.addCategory(Intent.CATEGORY_HOME);
        intent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
        startActivity(intent);
    }

    public void initAdNetwork() {
        if (adsPref.getAdStatus().equals(AD_STATUS_ON) && adsPref.getAdType().equals(ADMOB)) {
            loadAdMobBannerAd();
        } else if (adsPref.getAdStatus().equals(AD_STATUS_ON) && adsPref.getAdType().equals(FAN)) {
            loadFanBannerAd();
        } else if (adsPref.getAdStatus().equals(AD_STATUS_ON) && adsPref.getAdType().equals(STARTAPP)) {
            loadStartAppBannerAd();
        }
    }

    public void loadAdMobBannerAd() {
        if (!adsPref.getAdMobBannerId().equals("0")) {
            adContainerView = findViewById(R.id.admob_banner_view_container);
            adContainerView.post(() -> {
                adView = new AdView(this);
                adView.setAdUnitId(adsPref.getAdMobBannerId());
                adContainerView.removeAllViews();
                adContainerView.addView(adView);
                adView.setAdSize(Tools.getAdSize(this));
                adView.loadAd(Tools.getAdRequest(this));
                adView.setAdListener(new AdListener() {
                    @Override
                    public void onAdLoaded() {
                        // Code to be executed when an ad finishes loading.
                        adContainerView.setVisibility(View.VISIBLE);
                    }

                    @Override
                    public void onAdFailedToLoad(LoadAdError adError) {
                        // Code to be executed when an ad request fails.
                        adContainerView.setVisibility(View.GONE);
                    }

                    @Override
                    public void onAdOpened() {
                        // Code to be executed when an ad opens an overlay that
                        // covers the screen.
                    }

                    @Override
                    public void onAdClicked() {
                        // Code to be executed when the user clicks on an ad.
                    }

                    @Override
                    public void onAdLeftApplication() {
                        // Code to be executed when the user has left the app.
                    }

                    @Override
                    public void onAdClosed() {
                        // Code to be executed when the user is about to return
                        // to the app after tapping on an ad.
                    }
                });
            });
        }
    }

    private void loadFanBannerAd() {
        if (!adsPref.getFanBannerUnitId().equals("0")) {
            if (BuildConfig.DEBUG) {
                fanAdView = new com.facebook.ads.AdView(this, "IMG_16_9_APP_INSTALL#" + adsPref.getFanBannerUnitId(), AdSize.BANNER_HEIGHT_50);
            } else {
                fanAdView = new com.facebook.ads.AdView(this, adsPref.getFanBannerUnitId(), AdSize.BANNER_HEIGHT_50);
            }
            LinearLayout adContainer = findViewById(R.id.fan_banner_view_container);
            // Add the ad view to your activity layout
            adContainer.addView(fanAdView);
            com.facebook.ads.AdListener adListener = new com.facebook.ads.AdListener() {
                @Override
                public void onError(Ad ad, AdError adError) {
                    adContainer.setVisibility(View.GONE);
                }

                @Override
                public void onAdLoaded(Ad ad) {
                    adContainer.setVisibility(View.VISIBLE);
                }

                @Override
                public void onAdClicked(Ad ad) {

                }

                @Override
                public void onLoggingImpression(Ad ad) {

                }
            };
            com.facebook.ads.AdView.AdViewLoadConfig loadAdConfig = fanAdView.buildLoadAdConfig().withAdListener(adListener).build();
            fanAdView.loadAd(loadAdConfig);
        }
    }

    private void loadStartAppBannerAd() {
        if (!adsPref.getStartappAppID().equals("0")) {
            RelativeLayout bannerLayout = findViewById(R.id.startapp_banner_view_container);
            Banner banner = new Banner(this, new BannerListener() {
                @Override
                public void onReceiveAd(View banner) {
                    bannerLayout.setVisibility(View.VISIBLE);
                }

                @Override
                public void onFailedToReceiveAd(View banner) {
                    bannerLayout.setVisibility(View.GONE);
                }

                @Override
                public void onImpression(View view) {

                }

                @Override
                public void onClick(View banner) {
                }
            });
            bannerLayout.addView(banner);
        }
    }

    private boolean isServiceRunning() {
        ActivityManager manager = (ActivityManager) getSystemService(Context.ACTIVITY_SERVICE);
        assert manager != null;
        for (ActivityManager.RunningServiceInfo service : manager.getRunningServices(Integer.MAX_VALUE)) {
            if (RadioPlayerService.class.getName().equals(service.service.getClassName())) {
                return true;
            }
        }
        return false;
    }

    public void hideKeyboard() {
        try {
            getWindow().setSoftInputMode(WindowManager.LayoutParams.SOFT_INPUT_STATE_ALWAYS_HIDDEN);
            if (((getCurrentFocus() != null) && ((getCurrentFocus().getWindowToken() != null)))) {
                ((InputMethodManager) getSystemService(Context.INPUT_METHOD_SERVICE)).hideSoftInputFromWindow(getCurrentFocus().getWindowToken(), 0);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void updateConsentStatus() {
        if (BuildConfig.DEBUG) {
            ConsentDebugSettings debugSettings = new ConsentDebugSettings.Builder(this)
                    .setDebugGeography(ConsentDebugSettings.DebugGeography.DEBUG_GEOGRAPHY_NOT_EEA)
                    .addTestDeviceHashedId("TEST-DEVICE-HASHED-ID")
                    .build();
            ConsentRequestParameters params = new ConsentRequestParameters.Builder().setConsentDebugSettings(debugSettings).build();
            consentInformation = UserMessagingPlatform.getConsentInformation(this);
            consentInformation.requestConsentInfoUpdate(this, params, () -> {
                        if (consentInformation.isConsentFormAvailable()) {
                            loadForm();
                        }
                    },
                    formError -> {
                    });
        } else {
            ConsentRequestParameters params = new ConsentRequestParameters.Builder().build();
            consentInformation = UserMessagingPlatform.getConsentInformation(this);
            consentInformation.requestConsentInfoUpdate(this, params, () -> {
                        if (consentInformation.isConsentFormAvailable()) {
                            loadForm();
                        }
                    },
                    formError -> {
                    });
        }
    }

    public void loadForm() {
        UserMessagingPlatform.loadConsentForm(this, consentForm -> {
                    MainActivity.this.consentForm = consentForm;
                    if (consentInformation.getConsentStatus() == ConsentInformation.ConsentStatus.REQUIRED) {
                        consentForm.show(MainActivity.this, formError -> {
                            loadForm();
                        });
                    }
                },
                formError -> {
                }
        );
    }

    public void aboutDialog() {
        LayoutInflater layoutInflaterAndroid = LayoutInflater.from(MainActivity.this);
        View view = layoutInflaterAndroid.inflate(R.layout.custom_dialog_about, null);

        ((TextView) view.findViewById(R.id.txt_app_version)).setText(getString(R.string.sub_about_app_version) + " " + BuildConfig.VERSION_NAME);

        final AlertDialog.Builder alert = new AlertDialog.Builder(MainActivity.this);
        alert.setView(view);
        alert.setCancelable(false);
        alert.setPositiveButton(R.string.option_ok, (dialog, which) -> dialog.dismiss());
        alert.show();
    }

    public void searchAction() {
        FragmentManager fm = getSupportFragmentManager();
        FragmentSearch ft = new FragmentSearch();

        FragmentTransaction ftr = fm.beginTransaction();
        ftr.setTransition(FragmentTransaction.TRANSIT_FRAGMENT_OPEN);

        Fragment bottomFragment = fm.findFragmentById(R.id.fragment_container);
        assert bottomFragment != null;
        ftr.hide(bottomFragment);

        ftr.add(R.id.fragment_container, ft, getString(R.string.menu_search));
        ftr.addToBackStack(getString(R.string.menu_search));
        ftr.commit();
    }

    public void themeColor() {
        if (themePref.getCurrentTheme() == THEME_LIGHT) {
            lyt_collapse.setBackgroundColor(ContextCompat.getColor(getApplicationContext(), R.color.colorLight));
            img_previous.setColorFilter(ContextCompat.getColor(getApplicationContext(), R.color.black), PorterDuff.Mode.SRC_IN);
            img_next.setColorFilter(ContextCompat.getColor(getApplicationContext(), R.color.black), PorterDuff.Mode.SRC_IN);
            img_play.setColorFilter(ContextCompat.getColor(getApplicationContext(), R.color.black), PorterDuff.Mode.SRC_IN);
        } else if (themePref.getCurrentTheme() == THEME_DARK) {
            lyt_collapse.setBackgroundColor(ContextCompat.getColor(getApplicationContext(), R.color.colorToolbarDark));
            img_previous.setColorFilter(ContextCompat.getColor(getApplicationContext(), R.color.white), PorterDuff.Mode.SRC_IN);
            img_next.setColorFilter(ContextCompat.getColor(getApplicationContext(), R.color.white), PorterDuff.Mode.SRC_IN);
            img_play.setColorFilter(ContextCompat.getColor(getApplicationContext(), R.color.white), PorterDuff.Mode.SRC_IN);
        }
    }


    @Override
    public void onPause() {
        if (adsPref.getAdStatus().equals(AD_STATUS_ON) && adsPref.getAdType().equals(ADMOB)) {
            if (!adsPref.getAdMobBannerId().equals("0")) {
                if (adView != null) {
                    adView.pause();
                }
            }
        }
        super.onPause();
    }


    @Override
    public void onResume() {
        initComponent();
        themeColor();
        if (adsPref.getAdStatus().equals(AD_STATUS_ON) && adsPref.getAdType().equals(ADMOB)) {
            if (!adsPref.getAdMobBannerId().equals("0")) {
                if (adView != null) {
                    adView.resume();
                }
            }
        }
        super.onResume();
    }

    @Override
    protected void onDestroy() {
        Constant.is_app_open = false;

        if (adsPref.getAdStatus().equals(AD_STATUS_ON) && adsPref.getAdType().equals(ADMOB)) {
            if (!adsPref.getAdMobBannerId().equals("0")) {
                if (adView != null) {
                    adView.destroy();
                }
            }
        } else if (adsPref.getAdStatus().equals(AD_STATUS_ON) && adsPref.getAdType().equals(FAN)) {
            if (!adsPref.getFanBannerUnitId().equals("0")) {
                if (fanAdView != null) {
                    fanAdView.destroy();
                }
            }
        }

        super.onDestroy();
    }

    @Override
    public AssetManager getAssets() {
        return getResources().getAssets();
    }

}
