package com.app.yourradioapp.utils;

import com.app.yourradioapp.Config;
import com.app.yourradioapp.models.ItemRadio;
import com.google.android.exoplayer2.SimpleExoPlayer;

import java.io.Serializable;
import java.util.ArrayList;

import static com.app.yourradioapp.Config.ADMIN_PANEL_URL;

public class Constant implements Serializable {

    private static final long serialVersionUID = 1L;

    public static final String URL_RECENT_RADIO = ADMIN_PANEL_URL + "/services/api.php?get_recent_radio";
    public static final String URL_CATEGORY_RADIO = ADMIN_PANEL_URL + "/services/api.php?get_category_index";
    public static final String URL_RADIO_BY_CATEGORY = ADMIN_PANEL_URL + "/services/api.php?category_id=";
    public static final String URL_RADIO_SEARCH = ADMIN_PANEL_URL + "/services/api.php?search=";
    public static final String URL_PRIVACY_POLICY = ADMIN_PANEL_URL + "/services/api.php?get_privacy_policy";
    public static final String URL_PACKAGE_NAME = ADMIN_PANEL_URL + "/services/api.php?get_package_name";
    public static final String URL_ADS = ADMIN_PANEL_URL + "/services/api.php?get_ads";
    public static final String URL_SOCIAL = ADMIN_PANEL_URL + "/services/api.php?get_social";
    public static final String SECURITY_KEY = "&api_key=" + Config.API_KEY;

    public static final String JSON_ARRAY_NAME = "YourRadioApp";
    public static final String RECENT_RADIO_ID = "radio_id";
    public static final String RECENT_RADIO_NAME = "radio_name";
    public static final String RECENT_RADIO_IMAGE = "radio_image";
    public static final String RECENT_RADIO_URL = "radio_url";
    public static final String RECENT_CATEGORY_NAME = "category_name";

    public static final int DELAY_PROGRESS = 1000;
    public static final int DELAY_REFRESH_SHORT = 1000;
    public static final int DELAY_REFRESH_MEDIUM = 2000;

    public static String metadata;
    public static SimpleExoPlayer simpleExoPlayer;
    public static Boolean is_playing = false;
    public static Boolean radio_type = true;
    public static Boolean is_app_open = false;
    public static ArrayList<ItemRadio> item_radio = new ArrayList<>();
    public static int position = 0;

    public static final String AD_STATUS_ON = "on";
    public static final String ADMOB = "admob";
    public static final String FAN = "fan";
    public static final String STARTAPP = "startapp";

    //startapp native ad image parameters
    public static final int STARTAPP_IMAGE_XSMALL = 1; //for image size 100px X 100px
    public static final int STARTAPP_IMAGE_SMALL = 2; //for image size 150px X 150px
    public static final int STARTAPP_IMAGE_MEDIUM = 3; //for image size 340px X 340px
    public static final int STARTAPP_IMAGE_LARGE = 4; //for image size 1200px X 628px

    public static final int MAX_NUMBER_OF_NATIVE_AD_DISPLAYED = 5;

    public static final int THEME_LIGHT = 0;
    public static final int THEME_DARK = 1;
    public static final int THEME_PRIMARY = 2;

}