package com.app.yourradioapp.utils;

import android.os.AsyncTask;

import com.app.yourradioapp.models.ItemRadio;
import com.app.yourradioapp.services.parser.JSONParser;

import org.json.JSONArray;
import org.json.JSONObject;

import java.util.ArrayList;

public class RadioTask extends AsyncTask<String, String, String> {

    private RadioListListener radioListListener;
    private ArrayList<ItemRadio> arrayList;

    @SuppressWarnings("deprecation")
    public RadioTask(RadioListListener radioListListener) {
        this.radioListListener = radioListListener;
        arrayList = new ArrayList<>();
    }

    @Override
    protected void onPreExecute() {
        radioListListener.onStart();
        super.onPreExecute();
    }

    @Override
    protected String doInBackground(String... strings) {
        try {
            JSONObject mainJson = new JSONObject(JSONParser.okHttpGET(strings[0]));
            JSONArray jsonArray = mainJson.getJSONArray(Constant.JSON_ARRAY_NAME);
            JSONObject objJson;
            for (int i = 0; i < jsonArray.length(); i++) {
                objJson = jsonArray.getJSONObject(i);

                String radio_id = objJson.getString(Constant.RECENT_RADIO_ID);
                String radio_name = objJson.getString(Constant.RECENT_RADIO_NAME);
                String radio_image = objJson.getString(Constant.RECENT_RADIO_IMAGE);
                String radio_url = objJson.getString(Constant.RECENT_RADIO_URL);
                String category_name = objJson.getString(Constant.RECENT_CATEGORY_NAME);

                ItemRadio objItem = new ItemRadio(radio_id, radio_name, radio_image, radio_url, category_name);
                arrayList.add(objItem);
            }
            return "1";
        } catch (Exception e) {
            e.printStackTrace();
            return "0";
        }

    }

    @Override
    protected void onPostExecute(String s) {
        radioListListener.onEnd(s, arrayList);
        super.onPostExecute(s);
    }

    public interface RadioListListener {
        void onStart();
        void onEnd(String success, ArrayList<ItemRadio> arrayList);
    }

}